<!-- [QPRTemplateStart: jsobjectqueryhierarchyutils.js] -->

  var CONST_MAX_COUNT = 1000;
  var _iTotalMatchCount = -2, _sHeader = "";
  var _arWidths = new Array(), _arFixedWidths = new Array();
  var _bDisableFilterDesigner = false;
  var _iScrollX, _iScrollY;
  var _sCookieParameters = "";
  var _bCookiesSet = false;
  var _ServerFunctionCallFunc;

  var _Callback;
  
  function GetDynamicTreeChildren(voObject, vCallback)
  {
    _Callback = vCallback;
    var iModelId = voObject.iModelId;
    if (!iModelId) 
      iModelId = _iModelId;
    var bJavascriptRows = (typeof(_bJavascriptRows) != "undefined") ? _bJavascriptRows : false;
    var bIgnoreAccess = (typeof(_bIgnoreAccess) != "undefined") ? _bIgnoreAccess : false;
    var sHierarchyExtraParameters = (typeof(_sHierarchyExtraParameters) != "undefined") ? _sHierarchyExtraParameters : "";
    var sURL = sGetDynamicSubHierarchyURL(_sHierarchy, sGetCurrentFields(), "", _sConfigurationFile, sGetCurrentSortBy(), 
      CONST_MAX_COUNT, 0, 1, bJavascriptRows, bIgnoreAccess, sHierarchyExtraParameters);
    sURL = sSetParameter(ACT_PARAM_QUERY_ROOT_SHORT, sCreateExternalObjectId(_iProductId, iModelId, voObject.iObjectId), sURL);
    sURL = sSetParameter(ACT_PARAM_QUERY_FILTERS_SHORT, sGetCurrentFilters(), sURL);
    if (typeof(sGetExtraParametersForDynamicTreeExpansion) != "undefined")
      sURL = sGetExtraParametersForDynamicTreeExpansion(sURL);
    _iScrollX = $(window).scrollLeft();
    _iScrollY = $(window).scrollTop();
    if (_ServerFunctionCallFunc)
      _ServerFunctionCallFunc(sURL, GetDynamicTreeChildrenCallback);
    else
      CallServerFunction(sURL, GetDynamicTreeChildrenCallback);
  }

  function RegisterServerFunctionCallerFunction(vServerFunctionCallFunc)
  {
    _ServerFunctionCallFunc = vServerFunctionCallFunc;
  }

  function GetDynamicTreeChildrenCallback(result, data)
  {
    _Callback(result == "OK", data);
    window.scroll(_iScrollX, _iScrollY);
  }
  
  function OnLoad()
  { 
    RefreshToolbar();
    UpdateTree();
  }
  
  function OnResize()
  {
  }
  
  function AddToHeaderRow(vsData)
  {
    _sHeader += vsData;
  }
  
  function DrawTableTags(vsContent)
  {
    return '<div id="TableBody" style="overflow-y:scroll"><table id="ResizableTable" class="QueryTable" border="0" cellspacing="1" cellpadding="2" width="100%">' + vsContent + '</tbody></table></div>';
  }
  
  function RegisterServerCookieView()
  {
    var oMain = oGetMainView();
    if (oMain && oMain.OnServerCookieViewLoaded)
        oMain.OnServerCookieViewLoaded(self);
    else {
      // view opened outside of portal frameset (e.g. in booklet page)
      OnCookieLoaded();
    }
  }
    
  function LoadTreeView(vsTreeViewTemplate)
  {
    RegisterServerCookieView();

    if (bIsInPrintFrame()) {
      var oInformationView = oGetInformationViewFrame();
      if (oInformationView && (oInformationView.sGetCookieParameters)) {
        var sCookie = oInformationView.sGetCookieParameters();
        FSetCookie(sCookie, vsTreeViewTemplate);
        return;
      }
    }
  }

  function ReloadTree(vbPreventTreeStateSaving, vsTreeBaseURL)
  {
    var oTree = oGetTree();
    var oInfo = oGetInformationView();
    var oHeaderView = oInfo.oGetHeaderView();
    if (oTree && oHeaderView && oHeaderView.SubmitURL) {
      if ((!vsTreeBaseURL) || (vsTreeBaseURL.length ==0)) 
        vsTreeBaseURL = oTree.sGetDocumentLocation();
      if (vbPreventTreeStateSaving)
        oTree.PreventTreeStateSaving();
      oHeaderView.SubmitURL(vsTreeBaseURL, _sCookieParameters, _sTreeName,
                            true);
    }
  }

  function FSetCookie(vsCookie, vsTreeViewTemplate, vsTreeBaseURL)
  {
    _sCookieParameters = vsCookie;

    var oTree = oGetTree();
    if (oGetMainView()) {
      if (oTree && bExists(oTree.PreventTreeStateSaving))
        ReloadTree(true, vsTreeBaseURL);
      else {
        var sUrl = sSetParameter(ACT_PARAM_TEMPLATE, vsTreeViewTemplate, sGetDocumentLocation());
        OpenView(sUrl + "&" + _sCookieParameters,
                 bIsInPrintFrame() ? 'PrintView' : _sTreeName,
                 "", true, true);
      }
    }
    else if ((!_sCookieParameters) || (_sCookieParameters == "")) {
      // view opened outside of portal frameset (e.g. in booklet page)
      var sUrl = sSetParameter(ACT_PARAM_TEMPLATE, vsTreeViewTemplate, sGetDocumentLocation());
      OpenView(sUrl, _sTreeName, "", true);
    }
    _bCookiesSet = true;
  }
  
  function sGetCookieParameters()
  {
    var oTree = oGetTree();
    if (oTree && bExists(oTree.sGetExpandedNodes))
      _sCookieParameters = ACT_PARAM_EXPANDED_NODES + "=" + oTree.sGetExpandedNodes();
    return _sCookieParameters;
  }
<!-- [QPRTemplateEnd: jsobjectqueryhierarchyutils.js] -->
