// ----------------------------------------------------------------------------

; (function(voExports) {
  var i;
  for ( i in voExports )
    window[i] = voExports[i];
})((function() {

var _arResizableColWidths, _arFixedColWidths;
var _arRowCols = new Array();
var _iRowId = -1;;
var _bTableInitialized = false;

function Normalize(varWidths)
{
  var i, dSum = 0;
  if (varWidths) {
    for (i = 0; i < varWidths.length; ++i)
      dSum += parseFloat(varWidths[i]);
    for (i = 0; i < varWidths.length; ++i)
      varWidths[i] /= dSum;
  }
}

function InitializeResizableTable(varWidths, varFixedWidths)
{
  Normalize(varWidths);
  _arResizableColWidths = varWidths;
  _arFixedColWidths = varFixedWidths;
}

function FsGetColumnName(viId) 
{
  return "col" + viId + "_";
}

function FiGetColumnId()
{
  var iColId = _arRowCols[_iRowId];
  if (!iColId)
    iColId = 0
  return iColId;
}

function FsGetNextColumnId()
{
  var iColId = FiGetColumnId();
  _arRowCols[_iRowId] = iColId + 1;
  return FsGetColumnName(iColId) + _iRowId;
}

function FsGetParamString(vsParams)
{
  if (vsParams)
    return " " + vsParams;
  return "";
}

function FWriteHTML(vsHTML)
{
  document.write(vsHTML);
}

function SetCustomHTMLWriter(vWriter)
{
  FWriteHTML = vWriter;
}

function BD() // begin div
{
  FWriteHTML("<div id='TableBody' style='overflow-y:scroll'>");
}

function ED() // end div
{
  FWriteHTML("</div>");
}

function BT(vsParams) // begin table
{
  FWriteHTML("<table class='Resizable'" + FsGetParamString(vsParams) + " id='ResizableTable'>");
}

function ET() // end table
{
  FWriteHTML("</table>");
}

function BTH() // begin table header
{
  FWriteHTML("<thead>");
}

function ETH() // end table header
{
  FWriteHTML("</thead>");
}

function BTB() // begin table body
{
  FWriteHTML("<tbody>");
}

function ETB() // end table body
{
  FWriteHTML("</tbody>");
}

function BR(vsParams) // begin row
{
  ++_iRowId;
  FWriteHTML("<tr" + FsGetParamString(vsParams) + ">");
}

function ER() // end row
{
  FWriteHTML("</tr>");
}

function RCH(vsText, vsTitle, vsParams) // resizable column header
{
  var sId = FsGetNextColumnId();
  var sHtml = "<th id='" + sId + "'" + FsGetParamString(vsParams) + ">";
  if (vsTitle)
    sHtml += "<div id='" + sId + "p' title='" + vsTitle + "'>";
  else
    sHtml += "<div id='" + sId + "p'>";

  sHtml += vsText;
  sHtml += "</div></th>";
  FWriteHTML(sHtml);
}

function FCH(vsText, vsTitle, vsParams, viColWidth, vsWidthLabel) // fixed width column header
{
  var iColumnId = FiGetColumnId();
  var iWidth = iGetTableColumnWidth((viColWidth ? viColWidth : _arFixedColWidths[iColumnId]), (vsWidthLabel ? vsWidthLabel : (vsTitle ? vsTitle : vsText)));
  if (_arFixedColWidths)
    _arFixedColWidths[iColumnId] = iWidth;
  var sId = FsGetNextColumnId();
  var sHtml = "<th style='width: " + iWidth + "px;' id='" + sId + "'" + FsGetParamString(vsParams) + ">";
  if (vsTitle)
    sHtml += "<div style='width: " + iWidth + "px;' id='" + sId + "p' title='" + vsTitle + "'>";
  else
    sHtml += "<div style='width: " + iWidth + "px;' id='" + sId + "p' title='" + vsText + "'>";
  sHtml += vsText;
  sHtml += "</div></th>";
  FWriteHTML(sHtml);
  return iWidth;
}

function HCH(vsText, vsTitle, viWidth, vsParams) // hard-coded width column header
{
  var sId = FsGetNextColumnId();

  var sHtml = "<th style='width:" + viWidth + "px;' id='" + sId + "'" + FsGetParamString(vsParams) + ">";
  if (vsTitle)
    sHtml += "<div style='width:" + viWidth + "px;' id='" + sId + "p' title='" + vsTitle + "'>";
  else
    sHtml += "<div style='width:" + viWidth + "px;' id='" + sId + "p'>";

  sHtml += vsText;
  sHtml += "</div></th>";
  FWriteHTML(sHtml);
}

function RC(vsHTML, vsTitle, vsParams)
{
  if (_arFixedColWidths[FiGetColumnId()] == 0)
    _RC(vsHTML, vsTitle, vsParams);
  else
    _FC(vsHTML, vsTitle, vsParams);
}

function FC(vsHTML, vsTitle, vsParams)
{
  if (_arFixedColWidths[FiGetColumnId()] == 0)
    _RC(vsHTML, vsTitle, vsParams);
  else
    _FC(vsHTML, vsTitle, vsParams);
}

function _RC(vsText, vsTitle, vsParams) // resizable cell
{
  var sId = FsGetNextColumnId();

  var sHtml = "<td id='" + sId + "'" + FsGetParamString(vsParams) + ">";
  if (vsTitle)
    sHtml += "<div id='" + sId + "p' title='" + vsTitle + "'>";
  else
    sHtml += "<div id='" + sId + "p'>";

  sHtml += vsText;
  sHtml += "</div></td>";
  FWriteHTML(sHtml);
}

function _FC(vsHTML, vsTitle, vsParams) // fixed width cell
{
  var sId = FsGetNextColumnId();
  var sHtml = "<td id='" + sId + "'" + FsGetParamString(vsParams) + ">";
  if (vsTitle)
    sHtml += "<div id='" + sId + "p' title='" + vsTitle + "'>";
  else
    sHtml += "<div id='" + sId + "p'>";
  sHtml += vsHTML;
  sHtml += "</div></td>";
  FWriteHTML(sHtml);
}

function HC(vsHTML, vsTitle, viWidth, vsParams) // hard-coded width cell
{
  var sId = FsGetNextColumnId();

  var sHtml = "<td style='width:" + viWidth + "px;' id='" + sId + "'" + FsGetParamString(vsParams) + ">";
  if (vsTitle)
    sHtml += "<div style='width:" + viWidth + "px;' id='" + sId + "p' title='" + vsTitle + "'>";
  else
    sHtml += "<div style='width:" + viWidth + "px;' id='" + sId + "p'>";

  sHtml += vsHTML;
  sHtml += "</div></td>";
  FWriteHTML(sHtml);
}

function iResizableTableCurrentRowId()
{
  return _iRowId;
}

return { 
         InitializeResizableTable: InitializeResizableTable,
         SetCustomHTMLWriter: SetCustomHTMLWriter,
         BT: BT, ET: ET, BR: BR, ER: ER, RCH: RCH, FCH: FCH, RC: RC, FC: FC,
         HCH: HCH, HC: HC, BTH: BTH, ETH: ETH, BTB: BTB, ETB: ETB, BD: BD, ED: ED,
         iResizableTableCurrentRowId: iResizableTableCurrentRowId
       };
})());

// ----------------------------------------------------------------------------
